diff -uNr mythtv-0.21/libs/libmythtv/libmythtv.pro mythtv/libs/libmythtv/libmythtv.pro
--- mythtv-0.21/libs/libmythtv/libmythtv.pro	2008-02-18 23:59:32.000000000 +0100
+++ mythtv/libs/libmythtv/libmythtv.pro	2008-07-01 17:03:29.000000000 +0200
@@ -185,6 +185,7 @@
 HEADERS += mpeg/dvbdescriptors.h    mpeg/dishdescriptors.h
 HEADERS += mpeg/premieredescriptors.h
 HEADERS += mpeg/atsc_huffman.h      mpeg/iso639.h
+HEADERS += mpeg/freesat_huffman.h   mpeg/freesat_tables.h
 HEADERS += mpeg/iso6937tables.h
 HEADERS += mpeg/tsstats.h           mpeg/streamlisteners.h
 HEADERS += mpeg/h264utils.h
@@ -198,6 +199,7 @@
 SOURCES += mpeg/dvbdescriptors.cpp  mpeg/dishdescriptors.cpp
 SOURCES += mpeg/premieredescriptors.cpp
 SOURCES += mpeg/atsc_huffman.cpp    mpeg/iso639.cpp
+SOURCES += mpeg/freesat_huffman.cpp
 SOURCES += mpeg/iso6937tables.cpp
 SOURCES += mpeg/h264utils.cpp
 
@@ -312,6 +314,8 @@
     using_opengl_video:HEADERS += openglvideo.h
     using_opengl_video:SOURCES += openglvideo.cpp
 
+    using_glx_proc_addr_arb:DEFINES += USING_GLX_PROC_ADDR_ARB
+
     # Misc. frontend
     HEADERS += guidegrid.h              infostructs.h
     HEADERS += progfind.h               ttfont.h
@@ -499,6 +503,9 @@
 }
 
 mingw {
+    # For easier debugging: 
+    target.path = $${PREFIX}/bin
+
     DEFINES -= USING_OPENGL_VSYNC
     DEFINES += USING_D3D
 
@@ -515,3 +522,23 @@
 inc.files = programinfo.h remoteutil.h recordingtypes.h
 
 INSTALLS += inc
+
+unix {
+    SOURCES-=dbcheck.cpp
+    OBJECTS+=dbcheck.o
+    gcc431_workaround.target=dbcheck.o
+    gcc431_workaround.commands=$(CXX) -c $(CXXFLAGS) -O0 $(INCPATH) -o dbcheck.o dbcheck.cpp
+    gcc431_workaround.depends=dbcheck.h dbcheck.cpp
+    gcc431_workaround.depends+=datadirect.h videodisplayprofile.h
+    gcc431_workaround.depends+=../libmyth/mythcontext.h
+    gcc431_workaround.depends+=../libmyth/mythdbcon.h
+    gcc431_workaround.depends+=../libmyth/dbutil.h
+    gcc431_workaround.depends+=../libmyth/mythexp.h
+    gcc431_workaround.depends+=../libmyth/mythobservable.h
+    gcc431_workaround.depends+=../libmyth/mythsocket.h
+    gcc431_workaround.depends+=../libmyth/mythverbose.h
+    gcc431_workaround.depends+=../libmyth/mythevent.h
+    QMAKE_EXTRA_UNIX_TARGETS+=gcc431_workaround
+}
+
+include ( ../libs-targetfix.pro )
diff -uNr mythtv-0.21/libs/libmythtv/mpeg/dvbdescriptors.cpp mythtv/libs/libmythtv/mpeg/dvbdescriptors.cpp
--- mythtv-0.21/libs/libmythtv/mpeg/dvbdescriptors.cpp	2007-12-16 19:15:42.000000000 +0100
+++ mythtv/libs/libmythtv/mpeg/dvbdescriptors.cpp	2008-06-20 12:11:26.000000000 +0200
@@ -1,5 +1,6 @@
 #include "dvbdescriptors.h"
 #include "iso6937tables.h"
+#include "freesat_huffman.h"
 
 #include <unistd.h>
 #include <qtextcodec.h>
@@ -70,6 +71,9 @@
     if (!raw_length)
         return "";
 
+    if (src[0] == 0x1f)
+        return freesat_huffman_to_string(src, raw_length);
+
     if ((0x10 < src[0]) && (src[0] < 0x20))
     {
         // TODO: Handle multi-byte encodings
diff -uNr mythtv-0.21/libs/libmythtv/mpeg/dvbstreamdata.cpp mythtv/libs/libmythtv/mpeg/dvbstreamdata.cpp
--- mythtv-0.21/libs/libmythtv/mpeg/dvbstreamdata.cpp	2008-02-27 00:37:42.000000000 +0100
+++ mythtv/libs/libmythtv/mpeg/dvbstreamdata.cpp	2008-06-20 12:11:26.000000000 +0200
@@ -9,6 +9,7 @@
 #include "eithelper.h"
 
 #define PREMIERE_ONID 133
+#define FREESAT_EIT_PID 3842
 
 // service_id is synonymous with the MPEG program number in the PMT.
 DVBStreamData::DVBStreamData(uint desired_netid,  uint desired_tsid,
@@ -97,7 +98,7 @@
         return false;
 
     bool is_eit = false;
-    if (DVB_EIT_PID == pid)
+    if (DVB_EIT_PID == pid || FREESAT_EIT_PID == pid)
     {
         // Standard Now/Next Event Information Tables for this transport
         is_eit |= TableID::PF_EIT  == table_id;
@@ -130,7 +131,7 @@
         return SDToSectionSeen(psip.TableIDExtension(), psip.Section());
     }
 
-    if (DVB_EIT_PID == pid)
+    if (DVB_EIT_PID == pid || FREESAT_EIT_PID == pid)
     {
         // Standard Now/Next Event Information Tables for other transport
         is_eit |= TableID::PF_EITo == table_id;
@@ -327,7 +328,7 @@
         }
     }
 
-    if ((DVB_EIT_PID == pid || DVB_DNLONG_EIT_PID == pid) &&
+    if ((DVB_EIT_PID == pid || DVB_DNLONG_EIT_PID == pid || FREESAT_EIT_PID == pid) &&
         DVBEventInformationTable::IsEIT(psip.TableID()))
     {
         QMutexLocker locker(&_listener_lock);
@@ -428,6 +429,12 @@
         {
             add_pids.push_back(PREMIERE_EIT_SPORT_PID);
         }
+
+        if (find(cur_pids.begin(), cur_pids.end(),
+                 (uint) FREESAT_EIT_PID) == cur_pids.end())
+        {
+            add_pids.push_back(FREESAT_EIT_PID);
+        }
     }
     else
     {
@@ -457,6 +464,12 @@
         {
             del_pids.push_back(PREMIERE_EIT_SPORT_PID);
         }
+
+        if (find(cur_pids.begin(), cur_pids.end(),
+                 (uint) FREESAT_EIT_PID) == cur_pids.end())
+        {
+            del_pids.push_back(FREESAT_EIT_PID);
+        }
     }
 
     return add_pids.size() || del_pids.size();
diff -uNr mythtv-0.21/libs/libmythtv/mpeg/freesat_huffman.cpp mythtv/libs/libmythtv/mpeg/freesat_huffman.cpp
--- mythtv-0.21/libs/libmythtv/mpeg/freesat_huffman.cpp	1970-01-01 01:00:00.000000000 +0100
+++ mythtv/libs/libmythtv/mpeg/freesat_huffman.cpp	2008-06-20 12:11:26.000000000 +0200
@@ -0,0 +1,118 @@
+#include "freesat_huffman.h"
+
+#include <qstring.h>
+
+struct hufftab {
+    char last;
+    unsigned int value;
+    short bits;
+    char next;
+};
+
+#define START   '\0'
+#define STOP    '\0'
+#define ESCAPE  '\1'
+
+#include "freesat_tables.h"
+
+QString freesat_huffman_to_string(const unsigned char *src, uint size)
+{
+    if (src[1] == 1 || src[1] == 2)
+    {
+        QByteArray uncompressed(size * 3);
+        int p = 0;
+        struct hufftab *table;
+        unsigned table_length;
+        if (src[1] == 1)
+        {
+            table = fsat_huffman1;
+            table_length = sizeof(fsat_huffman1) / sizeof(fsat_huffman1[0]);
+        }
+        else
+        {
+            table = fsat_huffman2;
+            table_length = sizeof(fsat_huffman2) / sizeof(fsat_huffman2[0]);
+        }
+        unsigned value = 0, byte = 2, bit = 0;
+        while (byte < 6 && byte < size)
+        {
+            value |= src[byte] << ((5-byte) * 8);
+            byte++;
+        }
+        char lastch = START;
+
+        do
+        {
+            bool found = false;
+            unsigned bitShift = 0;
+            if (lastch == ESCAPE)
+            {
+                found = true;
+                // Encoded in the next 8 bits.
+                // Terminated by the first ASCII character.
+                char nextCh = (value >> 24) & 0xff;
+                bitShift = 8;
+                if ((nextCh & 0x80) == 0)
+                    lastch = nextCh;
+                if (p >= uncompressed.count())
+                    uncompressed.resize(p+10);
+                uncompressed[p++] = nextCh;
+            }
+            else
+            {
+                for (unsigned j = 0; j < table_length; j++)
+                {
+                    if (table[j].last == lastch)
+                    {
+                        unsigned mask = 0, maskbit = 0x80000000;
+                        for (short kk = 0; kk < table[j].bits; kk++)
+                        {
+                            mask |= maskbit;
+                            maskbit >>= 1;
+                        }
+                        if ((value & mask) == table[j].value)
+                        {
+                            char nextCh = table[j].next;
+                            bitShift = table[j].bits;
+                            if (nextCh != STOP && nextCh != ESCAPE)
+                            {
+                                if (p >= uncompressed.count())
+                                    uncompressed.resize(p+10);
+                                uncompressed[p++] = nextCh;
+                            }
+                            found = true;
+                            lastch = nextCh;
+                            break;
+                        }
+                    }
+                }
+            }
+            if (found)
+            {
+                // Shift up by the number of bits.
+                for (unsigned b = 0; b < bitShift; b++)
+                {
+                    value = (value << 1) & 0xfffffffe;
+                    if (byte < size)
+                        value |= (src[byte] >> (7-bit)) & 1;
+                    if (bit == 7)
+                    {
+                        bit = 0;
+                        byte++;
+                    }
+                    else bit++;
+                }
+            }
+            else
+            {
+                // Entry missing in table.
+                QString result = QString::fromUtf8(uncompressed, p);
+                result.append("...");
+                return result;
+            }
+        } while (lastch != STOP && value != 0);
+
+        return QString::fromUtf8(uncompressed, p);
+    }
+    else return QString("");
+}
diff -uNr mythtv-0.21/libs/libmythtv/mpeg/freesat_huffman.h mythtv/libs/libmythtv/mpeg/freesat_huffman.h
--- mythtv-0.21/libs/libmythtv/mpeg/freesat_huffman.h	1970-01-01 01:00:00.000000000 +0100
+++ mythtv/libs/libmythtv/mpeg/freesat_huffman.h	2008-06-20 12:11:26.000000000 +0200
@@ -0,0 +1,12 @@
+#ifndef _FREESAT_HUFFMAN_H_
+#define _FREESAT_HUFFMAN_H_
+
+// POSIX header
+#include <unistd.h>
+
+// Qt header
+#include <qstring.h>
+
+QString freesat_huffman_to_string(const unsigned char *compressed, uint size);
+
+#endif // _FREESAT_HUFFMAN_H_
diff -uNr mythtv-0.21/libs/libmythtv/mpeg/pespacket.cpp mythtv/libs/libmythtv/mpeg/pespacket.cpp
--- mythtv-0.21/libs/libmythtv/mpeg/pespacket.cpp	2006-09-07 20:55:03.000000000 +0200
+++ mythtv/libs/libmythtv/mpeg/pespacket.cpp	2008-03-31 17:23:20.000000000 +0200
@@ -6,10 +6,10 @@
 
 extern "C" {
 #include "mythconfig.h"
-#include "../libavcodec/avcodec.h"
-#include "../libavformat/avformat.h"
-#include "../libavutil/crc.h"
-#include "../libavutil/bswap.h"
+#include "libavcodec/avcodec.h"
+#include "libavformat/avformat.h"
+#include "libavutil/crc.h"
+#include "libavutil/bswap.h"
 }
 
 #include <vector>
diff -uNr mythtv-0.21/libs/libmythtv/NuppelVideoPlayer.cpp mythtv/libs/libmythtv/NuppelVideoPlayer.cpp
--- mythtv-0.21/libs/libmythtv/NuppelVideoPlayer.cpp	2008-03-08 01:07:31.000000000 +0100
+++ mythtv/libs/libmythtv/NuppelVideoPlayer.cpp	2008-06-02 19:33:00.000000000 +0200
@@ -741,6 +741,9 @@
     }
 
     InitFilters();
+
+    if (ringBuffer->InDVDMenuOrStillFrame())
+        ringBuffer->DVD()->SetRunSeekCellStart(true);
 }
 
 QString NuppelVideoPlayer::ReinitAudio(void)
@@ -996,8 +999,11 @@
         return;
     }
 
-    video_dim    = QSize((width + 15) & ~0xf, (height + 15) & ~0xf);
-    video_disp_dim=QSize(width, height);
+    if ((width > 0) && (height > 0))
+    {
+        video_dim      = QSize((width + 15) & ~0xf, (height + 15) & ~0xf);
+        video_disp_dim = QSize(width, height);
+    }
     video_aspect = (aspect > 0.0f) ? aspect : video_aspect;
     keyframedist = (keyframedistance > 0) ? keyframedistance : keyframedist;
 
@@ -2435,6 +2441,9 @@
             }
 
             avsync_delay = (buffer->timecode - currentaudiotime) * 1000;//usec
+            // prevents major jitter when pts resets during dvd title
+            if (avsync_delay > 2000000 && ringBuffer->isDVD())
+                avsync_delay = 90000;
             avsync_avg = (avsync_delay + (avsync_avg * 3)) / 4;
             if (!usevideotimebase)
             {
@@ -2507,8 +2516,7 @@
         return;
     }
 
-    if (ringBuffer->InDVDMenuOrStillFrame())
-        DisplayDVDButton();
+    DisplayDVDButton();
 
     videofiltersLock.lock();
     videoOutput->ProcessFrame(NULL, osd, videoFilters, pipplayer);
@@ -2524,7 +2532,8 @@
     prebuffering_lock.lock();
     if (prebuffering)
     {
-        if (ringBuffer->InDVDMenuOrStillFrame() && prebuffer_tries > 3)
+        if (ringBuffer->InDVDMenuOrStillFrame() && 
+            prebuffer_tries > 3)
         {
             prebuffering = false;
             prebuffer_tries = 0;
@@ -2532,7 +2541,8 @@
             return true;
         }
 
-        if (!audio_paused && audioOutput)
+        if (!ringBuffer->InDVDMenuOrStillFrame() && 
+            !audio_paused && audioOutput)
         {
            if (prebuffering)
                 audioOutput->Pause(prebuffering);
@@ -2663,8 +2673,7 @@
         yuv_wait.wakeAll();
     }
 
-    if (ringBuffer->InDVDMenuOrStillFrame())
-        DisplayDVDButton();
+    DisplayDVDButton();
 
     // handle Interactive TV
     if (GetInteractiveTV() && GetDecoder())
@@ -2835,9 +2844,6 @@
 
                 if (ringBuffer->InDVDMenuOrStillFrame())
                 {
-                    if (audioOutput)
-                        audioOutput->Pause(false);
-
                     if (nbframes == 0)
                     {
                         VERBOSE(VB_PLAYBACK, LOC_ERR + 
@@ -3795,8 +3801,11 @@
 
     int samples = len / samplesize;
 
-    if (ringBuffer->InDVDMenuOrStillFrame())
+    if (ringBuffer->isDVD() &&
+        ringBuffer->DVD()->InStillFrame())
+    {
         audioOutput->Drain();
+    }
 
     // If there is no warping, just send it to the audioOutput.
     if (!usevideotimebase)
@@ -4493,7 +4502,14 @@
         audioOutput->Reset();
 
     if (osd)
+    {
         osd->ClearAllCCText();
+        if (ringBuffer->InDVDMenuOrStillFrame())
+        {
+            osd->HideSet("subtitles");
+            osd->ClearAll("subtitles");
+        }
+    }
 
     SetDeleteIter();
     SetCommBreakIter();
@@ -6970,15 +6986,15 @@
 
 void NuppelVideoPlayer::DisplayDVDButton(void)
 {
-    if (!ringBuffer->InDVDMenuOrStillFrame() || !osd)
+    if (!ringBuffer->isDVD() || !osd)
         return;
 
     VideoFrame *buffer = videoOutput->GetLastShownFrame();
 
-    int numbuttons = ringBuffer->DVD()->NumMenuButtons();
+    bool numbuttons = ringBuffer->DVD()->NumMenuButtons();
     bool osdshown = osd->IsSetDisplaying("subtitles");
 
-    if ((numbuttons == 0) || 
+    if ((!numbuttons) || 
         (osdshown) ||
         (dvd_stillframe_showing && buffer->timecode > 0) ||
         ((!osdshown) && 
@@ -6990,39 +7006,40 @@
     }
 
     OSDSet *subtitleOSD = NULL;
-    AVSubtitleRect *highlightButton = ringBuffer->DVD()->GetMenuButton();
-
-    if (highlightButton != NULL)
+    AVSubtitle *dvdSubtitle = ringBuffer->DVD()->GetMenuSubtitle();
+    AVSubtitleRect *hl_button = NULL;
+    if (dvdSubtitle != NULL)
     {
+        hl_button = &(dvdSubtitle->rects[0]);
         osd->HideSet("subtitles");
         osd->ClearAll("subtitles");
         subtitleLock.lock();
-        uint h = ringBuffer->DVD()->ButtonHeight();
-        uint w = ringBuffer->DVD()->ButtonWidth();
-        uint bitmapHeight = highlightButton->h;
-        uint bitmapWidth  = highlightButton->w;
-        int linesize = highlightButton->linesize;
-        int x1 = highlightButton->x;
-        int y1 = highlightButton->y;
-        uint btnX = ringBuffer->DVD()->ButtonPosX();
-        uint btnY = ringBuffer->DVD()->ButtonPosY();
+        uint h = hl_button->h;
+        uint w  = hl_button->w;
+        int linesize = hl_button->linesize;
+        int x1 = hl_button->x;
+        int y1 = hl_button->y;
+        QRect buttonPos = ringBuffer->DVD()->GetButtonCoords();
         subtitleOSD = osd->GetSet("subtitles");
-
-        if ((w + x1) > bitmapWidth)
-            w = w - ((w + x1) - bitmapWidth);
-       
-        if ((h + y1) > bitmapHeight)
-            h = h - ((h + y1) - bitmapHeight);
-        
-        QImage hl_button(w, h, 32);
-        hl_button.setAlphaBuffer(true);
-        for (uint y = 0; y < h; y++)
+        QImage hl_image(w, h, 32);
+        hl_image.setAlphaBuffer(true);
+        uint8_t color;
+        uint32_t pixel;
+        QPoint currentPos = QPoint(0,0);
+        for (uint y = 2; y < h; y++)
         {
             for (uint x = 0; x < w; x++)
             {
-                uint8_t color = highlightButton->bitmap[(y+y1)*linesize+(x+x1)];
-                uint32_t pixel = highlightButton->rgba_palette[color];
-                hl_button.setPixel(x, y, pixel);
+                currentPos.setY(y);
+                currentPos.setX(x);
+                color = hl_button->bitmap[(y)*linesize+(x)];
+                // use rgba palette from dvd nav for drawing
+                // highlighted button
+                if (buttonPos.contains(currentPos))
+                    pixel = dvdSubtitle->rects[1].rgba_palette[color];
+                else
+                    pixel = hl_button->rgba_palette[color];
+                hl_image.setPixel(x, y, pixel);
             }
         }
 
@@ -7037,19 +7054,19 @@
 
         if ((hmult < 0.99) || (hmult > 1.01) || (vmult < 0.99) || (vmult > 1.01)) 
         {
-            btnX = (int)    (btnX * hmult);
-            btnY = (int)    (btnY * vmult);
+            x1 = (int)    (x1 * hmult);
+            y1 = (int)    (y1 * vmult);
             w    = (int)ceil(w    * hmult);
             h    = (int)ceil(h    * vmult);
 
-            hl_button = hl_button.smoothScale(w, h);
+            hl_image = hl_image.smoothScale(w, h);
         } 
         else 
             hmult = vmult = 1.0;
 
         OSDTypeImage* image = new OSDTypeImage();
-        image->SetPosition(QPoint(btnX, btnY), hmult, vmult);
-        image->Load(hl_button);
+        image->SetPosition(QPoint(x1, y1), hmult, vmult);
+        image->Load(hl_image);
         image->SetDontRoundPosition(true);
 
         subtitleOSD->AddType(image);
diff -uNr mythtv-0.21/libs/libmythtv/RingBuffer.cpp mythtv/libs/libmythtv/RingBuffer.cpp
--- mythtv-0.21/libs/libmythtv/RingBuffer.cpp	2008-02-26 22:13:09.000000000 +0100
+++ mythtv/libs/libmythtv/RingBuffer.cpp	2008-06-23 02:35:56.000000000 +0200
@@ -181,17 +181,14 @@
         is_dvd = true;
         dvdPriv = new DVDRingBufferPriv();
         startreadahead = false;
-        int pathLen = filename.find("/", 4);
-        if (pathLen != -1)
-        {
-            QString tempFilename = filename.right(filename.length() -  pathLen);
 
-            QFile checkFile(tempFilename);
-            if (!checkFile.exists())
-                filename = "/dev/dvd";
-            else
-                filename = tempFilename;
-        }
+        if (filename.left(6) == "dvd://")  // 'Play DVD' sends "dvd:/" + dev
+            filename.remove(0,5);          //             e.g. "dvd://dev/sda"
+        else                               // Less correct URI "dvd:" + path
+            filename.remove(0,4);          //             e.g. "dvd:/videos/ET"
+
+        if (QFile::exists(filename))
+            VERBOSE(VB_PLAYBACK, "OpenFile() trying DVD at " + filename);
         else
         {
             filename = "/dev/dvd";
diff -uNr mythtv-0.21/libs/libmythtv/scanwizardhelpers.cpp mythtv/libs/libmythtv/scanwizardhelpers.cpp
--- mythtv-0.21/libs/libmythtv/scanwizardhelpers.cpp	2008-01-14 17:45:33.000000000 +0100
+++ mythtv/libs/libmythtv/scanwizardhelpers.cpp	2008-04-14 23:34:25.000000000 +0200
@@ -1,5 +1,5 @@
 /* -*- Mode: c++ -*-
- * $Id: scanwizardhelpers.cpp 15437 2008-01-14 16:45:33Z danielk $
+ * $Id: scanwizardhelpers.cpp 17053 2008-04-14 21:34:25Z danielk $
  * vim: set expandtab tabstop=4 shiftwidth=4:
  *
  * Original Project
@@ -439,6 +439,8 @@
         country = UK;
     else if (qtcountry == QLocale::Spain)
         country = ES;
+    else if (qtcountry == QLocale::NewZealand)
+        country = NZ;
 #endif
 
     setLabel(tr("Country"));
@@ -448,6 +450,7 @@
     addSelection(QObject::tr("United Kingdom"), "uk", country == UK);
     addSelection(QObject::tr("Germany"),        "de", country == DE);
     addSelection(QObject::tr("Spain"),          "es", country == ES);
+    addSelection(QObject::tr("New Zealand"),    "nz", country == NZ);
 }
 
 AnalogPane::AnalogPane() :
diff -uNr mythtv-0.21/libs/libmythtv/scanwizardhelpers.h mythtv/libs/libmythtv/scanwizardhelpers.h
--- mythtv-0.21/libs/libmythtv/scanwizardhelpers.h	2008-01-27 20:21:41.000000000 +0100
+++ mythtv/libs/libmythtv/scanwizardhelpers.h	2008-04-14 23:34:25.000000000 +0200
@@ -1,5 +1,5 @@
 /* -*- Mode: c++ -*-
- * $Id: scanwizardhelpers.h 15622 2008-01-27 19:21:41Z danielk $
+ * $Id: scanwizardhelpers.h 17053 2008-04-14 21:34:25Z danielk $
  * vim: set expandtab tabstop=4 shiftwidth=4:
  *
  * Original Project
@@ -200,6 +200,7 @@
         UK,
         DE,
         ES,
+        NZ,
     };
 
     ScanCountry();
diff -uNr mythtv-0.21/libs/libmythtv/siscan.cpp mythtv/libs/libmythtv/siscan.cpp
--- mythtv-0.21/libs/libmythtv/siscan.cpp	2008-01-26 08:29:09.000000000 +0100
+++ mythtv/libs/libmythtv/siscan.cpp	2008-05-26 13:26:07.000000000 +0200
@@ -1124,6 +1124,12 @@
     {   // The service is in database, update it
         emit ServiceScanUpdateText(
             tr("Updating %1").arg(common_status_info));
+
+        bool useeit = false;
+        bool hidden = false;
+
+        ChannelUtil::GetChannelSettings(chanid, useeit, hidden);
+
         ChannelUtil::UpdateChannel(
             db_mplexid, db_source_id, chanid,
             callsign,
@@ -1131,7 +1137,7 @@
             chan_num,
             pmt->ProgramNumber(),
             0, 0,
-            false, false, false, QString::number(freqid));
+            useeit, hidden, false, QString::number(freqid));
     }
 }
 
@@ -1510,8 +1516,17 @@
         {   // The service is in database & we have good info, update it
             emit ServiceScanUpdateText(tr("Updating %1").arg(service_name));
 
+            bool useeit = false;
+            bool hidden = false;
+
+            ChannelUtil::GetChannelSettings(chanid, useeit, hidden);
+
             if (!renameChannels)
                 chan_num = ChannelUtil::GetChanNum(chanid);
+            else
+                useeit = (sdt->HasEITSchedule(i) ||
+                            sdt->HasEITPresentFollowing(i) || 
+                            force_guide_present);
 
             ChannelUtil::UpdateChannel(
                 db_mplexid,
@@ -1522,10 +1537,8 @@
                 chan_num,
                 sdt->ServiceID(i),
                 0, 0, 
-                sdt->HasEITSchedule(i) ||
-                sdt->HasEITPresentFollowing(i) ||
-                force_guide_present,
-                false, false, QString::null,
+                useeit,
+                hidden, false, QString::null,
                 QString::null, QString::null, QString::null,
                 default_authority);
         }
diff -uNr mythtv-0.21/libs/libmythtv/ttfont.cpp mythtv/libs/libmythtv/ttfont.cpp
--- mythtv-0.21/libs/libmythtv/ttfont.cpp	2007-06-08 12:41:38.000000000 +0200
+++ mythtv/libs/libmythtv/ttfont.cpp	2008-04-30 23:45:57.000000000 +0200
@@ -629,10 +629,16 @@
    }
 
    loadedfontsize = (int)(fontsize * m_hmult);
-   xdpi = (int)(xdpi * m_wscale);
 
    FT_Set_Char_Size(face, 0, loadedfontsize * 64, xdpi, ydpi);
 
+   FT_Matrix tmatrix;
+   tmatrix.xx = (FT_Fixed)(m_wscale * (1<<16));
+   tmatrix.yx = (FT_Fixed)0;
+   tmatrix.xy = (FT_Fixed)0;
+   tmatrix.yy = (FT_Fixed)(1<<16);
+   FT_Set_Transform(face, &tmatrix, 0);
+
    n = face->num_charmaps;
 
    for (i = 0; i < n; i++)
diff -uNr mythtv-0.21/libs/libmythtv/tv_play.cpp mythtv/libs/libmythtv/tv_play.cpp
--- mythtv-0.21/libs/libmythtv/tv_play.cpp	2008-03-06 23:23:26.000000000 +0100
+++ mythtv/libs/libmythtv/tv_play.cpp	2008-05-12 05:08:03.000000000 +0200
@@ -3010,7 +3010,7 @@
         return;
 
     if (activerbuffer &&
-        activerbuffer->isDVD() && activerbuffer->DVD()->IsInMenu())
+        activerbuffer->isDVD())
     {
         for (unsigned int i = 0; i < actions.size(); i++)
         {
@@ -5880,10 +5880,14 @@
             break;
         }
         case kScheduleProgramFinder:
+            if (!paused)
+                DoPause(false);
             RunProgramFind(false, false);
             break;
         case kScheduledRecording:
         {
+            if (!paused)
+                DoPause(false);
             QMutexLocker locker(&pbinfoLock);
             ScheduledRecording *record = new ScheduledRecording();
             record->loadByProgram(playbackinfo);
diff -uNr mythtv-0.21/libs/libmythtv/util-opengl.cpp mythtv/libs/libmythtv/util-opengl.cpp
--- mythtv-0.21/libs/libmythtv/util-opengl.cpp	2007-12-12 05:51:42.000000000 +0100
+++ mythtv/libs/libmythtv/util-opengl.cpp	2008-04-02 18:33:07.000000000 +0200
@@ -306,7 +306,9 @@
 {
     __GLXextFuncPtr ret = NULL;
 
-#if GLX_VERSION_1_4
+#if USING_GLX_PROC_ADDR_ARB
+    X11S(ret = glXGetProcAddressARB((const GLubyte*)procName.latin1()));
+#elif GLX_VERSION_1_4
     X11S(ret = glXGetProcAddress((const GLubyte*)procName.latin1()));
 #elif GLX_ARB_get_proc_address
     X11S(ret = glXGetProcAddressARB((const GLubyte*)procName.latin1()));
diff -uNr mythtv-0.21/libs/libmythtv/videoout_ivtv.cpp mythtv/libs/libmythtv/videoout_ivtv.cpp
--- mythtv-0.21/libs/libmythtv/videoout_ivtv.cpp	2008-03-08 01:07:31.000000000 +0100
+++ mythtv/libs/libmythtv/videoout_ivtv.cpp	2008-06-07 22:51:13.000000000 +0200
@@ -411,7 +411,7 @@
 
     db_vdisp_profile->SetVideoRenderer("ivtv");
 
-    allowpreviewepg = false;
+    allowpreviewepg = true;
 
     videoDevice = gContext->GetSetting("PVR350VideoDev");
 
diff -uNr mythtv-0.21/libs/libmythtv/videoout_xv.cpp mythtv/libs/libmythtv/videoout_xv.cpp
--- mythtv-0.21/libs/libmythtv/videoout_xv.cpp	2008-03-08 01:07:31.000000000 +0100
+++ mythtv/libs/libmythtv/videoout_xv.cpp	2008-04-02 19:52:17.000000000 +0200
@@ -3820,10 +3820,11 @@
     int port_min = xv_attribute_min[attribute];
     int port_max = xv_attribute_max[attribute];
     int range    = port_max - port_min;
-    
-    int tmpval = (int) roundf(range * 0.01f * newValue);
-    int value   = min(tmpval + port_min, port_max);
 
+    int tmpval2 = (newValue + valAdj) % 100; 
+    int tmpval3 = (int) roundf(range * 0.01f * tmpval2); 
+    int value   = min(tmpval3 + port_min, port_max); 
+    
     xv_set_attrib(XJ_disp, xv_port, attrName.ascii(), value);
 
 #ifdef USING_XVMC
diff -uNr mythtv-0.21/libs/libmythui/libmythui.pro mythtv/libs/libmythui/libmythui.pro
--- mythtv-0.21/libs/libmythui/libmythui.pro	2008-01-31 23:18:37.000000000 +0100
+++ mythtv/libs/libmythui/libmythui.pro	2008-06-04 06:05:51.000000000 +0200
@@ -84,3 +84,5 @@
         inc.files += mythpainter_ogl.h
     }
 }
+
+include ( ../libs-targetfix.pro )
diff -uNr mythtv-0.21/libs/libmythupnp/libmythupnp.pro mythtv/libs/libmythupnp/libmythupnp.pro
--- mythtv-0.21/libs/libmythupnp/libmythupnp.pro	2008-01-23 07:02:16.000000000 +0100
+++ mythtv/libs/libmythupnp/libmythupnp.pro	2008-06-04 06:05:51.000000000 +0200
@@ -43,6 +43,9 @@
 LIBS += $$EXTRA_LIBS
 
 mingw {
+    # For easier debugging: 
+    target.path = $${PREFIX}/bin
+
     HEADERS += darwin-sendfile.h
     SOURCES += darwin-sendfile.c
 }
@@ -70,3 +73,5 @@
 
     QMAKE_LFLAGS_SHLIB += -flat_namespace
 }
+
+include ( ../libs-targetfix.pro )
diff -uNr mythtv-0.21/libs/libmythupnp/ssdp.cpp mythtv/libs/libmythupnp/ssdp.cpp
--- mythtv-0.21/libs/libmythupnp/ssdp.cpp	2007-12-18 03:51:27.000000000 +0100
+++ mythtv/libs/libmythupnp/ssdp.cpp	2008-03-15 18:53:54.000000000 +0100
@@ -251,7 +251,7 @@
         // Parse request Type
         // ------------------------------------------------------------------
 
-        // cout << "SSDP::ProcessData - requestLine: " << sRequestLine << endl;
+        VERBOSE(VB_UPNP, QString( "SSDP::ProcessData - requestLine: %1" ).arg( sRequestLine ));
 
         SSDPRequestType eType = ProcessRequestLine( sRequestLine );
 
@@ -349,7 +349,9 @@
     QString sMX  = GetHeaderValue( sHeaders, "MX" , "" );
     int     nMX  = 0;
 
-    //cout << "*** SSDP ProcessSearchrequest : [" << sST << "] MX = " << nMX << endl;
+    VERBOSE( VB_UPNP, QString( "SSDP::ProcessSearchrequest : [%1] MX=%2" )
+                         .arg( sST )
+                         .arg( nMX ));
 
     // ----------------------------------------------------------------------
     // Validate Header Values...
@@ -388,7 +390,7 @@
         // Excute task now for fastest response & queue for time-delayed response
         // -=>TODO: To be trully uPnp compliant, this Execute should be removed.
 
-        pTask->Execute( NULL );
+        //pTask->Execute( NULL );
 
         UPnp::g_pTaskQueue->AddTask( nNewMX, pTask );
 
@@ -433,6 +435,16 @@
     QString sUSN     = GetHeaderValue( headers, "USN"           , "" );
     QString sCache   = GetHeaderValue( headers, "CACHE-CONTROL" , "" );
 
+    VERBOSE( VB_UPNP, QString( "SSDP::ProcessSearchResponse \n"
+                               "DescURL=%1\n"
+                               "ST     =%2\n"
+                               "USN    =%3\n"
+                               "Cache  =%4")
+                         .arg( sDescURL )
+                         .arg( sST      )
+                         .arg( sUSN     )
+                         .arg( sCache   ));
+
     int nPos = sCache.find( "max-age", 0, false );
 
     if (nPos < 0)
@@ -460,6 +472,19 @@
     QString sUSN     = GetHeaderValue( headers, "USN"           , "" );
     QString sCache   = GetHeaderValue( headers, "CACHE-CONTROL" , "" );
 
+    VERBOSE( VB_UPNP, QString( "SSDP::ProcessNotify\n"
+                               "DescURL=%1\n"
+                               "NTS    =%2\n"
+                               "NT     =%3\n"
+                               "USN    =%4\n"
+                               "Cache  =%5" )
+                         .arg( sDescURL )
+                         .arg( sNTS     )
+                         .arg( sNT      )
+                         .arg( sUSN     )
+                         .arg( sCache   ));
+
+
     if (sNTS.contains( "ssdp:alive"))
     {
         int nPos = sCache.find( "max-age", 0, false );
@@ -559,6 +584,12 @@
 
     QString sUserAgent = pRequest->GetHeaderValue( "User-Agent", "" );
 
+    VERBOSE( VB_UPNP, QString( "SSDPExtension::GetDeviceDesc - Host=%1 Port=%2 UserAgent=%3" )
+                         .arg( pRequest->GetHostAddress() )
+                         .arg( m_nServicePort )
+                         .arg( sUserAgent ));
+
+
     UPnp::g_UPnpDeviceDesc.GetValidXML( pRequest->GetHostAddress(), 
                                         m_nServicePort,
                                         pRequest->m_response,
@@ -578,11 +609,18 @@
 
     if (QFile::exists( pRequest->m_sFileName ))
     {
+        VERBOSE( VB_UPNP, QString( "SSDPExtension::GetFile( %1 ) - Exists" )
+                             .arg( pRequest->m_sFileName ));
 
         pRequest->m_eResponseType                     = ResponseTypeFile;
         pRequest->m_nResponseStatus                   = 200;
         pRequest->m_mapRespHeaders[ "Cache-Control" ] = "no-cache=\"Ext\", max-age = 5000";
     }
+    else
+    {
+        VERBOSE( VB_UPNP, QString( "SSDPExtension::GetFile( %1 ) - Not Found" )
+                             .arg( pRequest->m_sFileName ));
+    }
 
 }
 
@@ -596,6 +634,8 @@
     int           nCount = 0;
     NameValueList list;
 
+    VERBOSE( VB_UPNP, "SSDPExtension::GetDeviceList" );
+
     cache.Lock();
 
     QString     sXML;
